﻿

using HaloMap;
using System.IO;
using LazyIO;
namespace HaloMap
{
    public class MapIndex : LazyIO.LazyIO
    {
        #region layout

        Int primaryMagicConstant;
        Int tagListCount;
        Int objectIndexPointer;
        Ident scenarioID;
        Ident firstIdent;
        Int unknown;
        Int objectCount;
        [Size(4)]
        String tags;

        #endregion

        #region fields

        MapHeader header;
        int secondaryMagicConstant;

        #endregion

        #region properties

        public int ObjectIndexOffset { get { return objectIndexPointer.Value - PrimaryMagic; } }
        public int ObjectCount { get { return objectCount.Value; } }
        public int PrimaryMagic { get { return primaryMagicConstant.Value - (header.IndexOffset + 32); } }
        public int SecondaryMagic { get { return secondaryMagicConstant - header.MetaStart; } }

        #endregion

        public MapIndex(MapHeader header)
        {
            this.header = header;
        }

        public override void Read(EndianReader br)
        {
            br.BaseStream.Position = header.IndexOffset;
            base.Read(br);
            br.BaseStream.Position = (ObjectIndexOffset + 8);
            secondaryMagicConstant = br.ReadInt32();
        }
    }
}
