﻿using System.Windows.Forms;
using System;

namespace HaloMap
{
    /// <summary>
    /// The base class for controls used in Viewing MetaItems
    /// </summary>
    public partial class MetaItemViewer : UserControl
    {
        #region fields

        const int WM_PAINT = 0x00f;
        bool paint = true;

        #endregion
        #region constructor

        public MetaItemViewer()
        {
            InitializeComponent();
        }

        #endregion
        #region methods

        public virtual void UpdateControl()
        {
        }
        public void BeginUpdate()
        {
            paint = false;
        }
        protected sealed override void WndProc(ref System.Windows.Forms.Message m)
        {
            if (m.Msg == WM_PAINT)
            {
                if (paint)
                {
                    base.WndProc(ref m);
                }
                else
                {
                    m.Result = IntPtr.Zero;
                }
            }
            else
            {
                base.WndProc(ref m);
            }
        }
        public void EndUpdate()
        {
            paint = true;
        }

        #endregion
    }
}
