﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using LazyIO;

namespace HaloMap
{
    public class MetaPanel : Panel
    {
        #region properties

        const int WM_PAINT = 0x00f;
        bool paint = true;
        public ViewType Viewing
        {
            get;
            set;
        }

        #endregion
        #region constructor

        public MetaPanel()
            :base()
        {
            BackColor = Color.Transparent;
            Dock = DockStyle.Fill;
            AutoScroll = true;
        }

        #endregion
        #region methods

        public void UpdateControl()
        {
            BeginUpdate();
            foreach (Control c in Controls)
            {
                if(c.GetType().IsSubclassOf(typeof(MetaItemViewer)))
                {
                    MetaItemViewer miv = (MetaItemViewer)c;
                    miv.UpdateControl();
                }
            }
            EndUpdate();
            Refresh();
        }
        public void BeginUpdate()
        {
            paint = false;
        }
        public void EndUpdate()
        {
            paint = true;
        }
        protected override void WndProc(ref Message m)
        {
            if (m.Msg == WM_PAINT)
            {
                if (paint)
                {
                    base.WndProc(ref m);
                }
                else
                {
                    m.Result = IntPtr.Zero;
                }
            }
            else
            {
                base.WndProc(ref m);
            }
        }

        #endregion
    }
}
