﻿using System.Collections;
using System.Windows.Forms;
using LazyIO;

namespace HaloMap
{
    public partial class ReflexiveViewer : MetaItemViewer
    {
        #region properties

        IList reflexive
        {
            get;
            set;
        }

        public ViewType viewing
        {
            get;
            set;
        }

        #endregion
        #region constructor

        public ReflexiveViewer()
        {
            InitializeComponent();
        }

        public ReflexiveViewer(IList reflexiveToView, string name)
            :this()
        {
            reflexive = reflexiveToView;
            expand.TitleText = name;
            expand.Expanded = false;
            Dock = DockStyle.Top;
        }

        #endregion
        #region methods

        public void SetViewing(ViewType viewing)
        {
            this.viewing = viewing;
        }
        void AddChunksToComboBox()
        {
            cmbChunk.Items.Clear();
            for (int i = 0; i < reflexive.Count; i++)
            {
                cmbChunk.Items.Add(i.ToString());
            }
        }
        void cmbChunk_SelectedIndexChanged(object sender, System.EventArgs e)
        {
            int idx = cmbChunk.SelectedIndex;
            if (idx > reflexive.Count || idx < 0) return;
            BeginUpdate();
            Chunk chunk = (Chunk)reflexive[idx];
            chunk.PopulateMetaPanel(panel, viewing, false);
            EndUpdate();
        }
        public override void UpdateControl()
        {
            BeginUpdate();
            SuspendLayout();
            expand.Size = new System.Drawing.Size(expand.Size.Width, 50);
            expand.Expanded = false;
            AddChunksToComboBox();
            panel.Controls.Clear();
            Enabled = reflexive.Count > 0;
            ResumeLayout();
            EndUpdate();
        }

        #endregion
    }    
}
