﻿using System.Windows.Forms;
using System.Drawing;

namespace HaloMap
{
    public partial class SIDViewer : MetaItemViewer
    {
        #region properties

        public static StringList Strings
        {
            get;
            set;
        }

        StringID stringID
        {
            get;
            set;
        }

        #endregion
        #region constructor

        public SIDViewer()
        {
            InitializeComponent();
        }

        public SIDViewer(StringID sid)
            :this()
        {
            stringID = sid;
            lblNameAndComments.Text = MetaItemBase.GetNameLabel(sid);
            SetUp();
            cmbSID.SelectedIndexChanged += new System.EventHandler(Selected_StringID_Changed);
            Dock = DockStyle.Top;
        }

        #endregion
        #region methods

        void SetUp()
        {
            if (Strings == null)
            {
                SetSize();
                return;
            }
            if (cmbSID.Items.Count == 0)
            {
                cmbSID.SelectedIndexChanged -= new System.EventHandler(Selected_StringID_Changed);
                cmbSID.Items.AddRange(Strings.ToArray());
                int idx = stringID.Index;
                if (idx < Strings.Count && idx >= 0)
                {
                    cmbSID.SelectedIndex = idx;
                }
                else
                {
                    cmbSID.SelectedIndex = 0; ; // usually ""
                }
            }
            cmbSID.SelectedIndexChanged += new System.EventHandler(Selected_StringID_Changed);
            SetSize();
        }
        void SetSize()
        {
            cmbSID.Width = (cmbSID.Text.Length * 5) + 50;
            int labelX = cmbSID.Location.X + cmbSID.Width + 6;
            lblNameAndComments.Location = new Point(labelX, lblNameAndComments.Location.Y);
        }
        void Selected_StringID_Changed(object sender, System.EventArgs e)
        {
            if (Strings == null) return;
            int idx = cmbSID.SelectedIndex;
            if (idx < Strings.Count && idx >= 0)
            {
                HaloString hs = Strings[idx];
                stringID.Update(hs.Index, (byte)hs.Value.Length);
            }
            SetSize();
        }
        public override void UpdateControl()
        {
            BeginUpdate();
            SetUp();
            EndUpdate();
        }

        #endregion
    }
}
