﻿using System;
using System.IO;
using LazyIO;

namespace HaloMap
{
    public sealed class Dependency : Ident
    {
        #region -  properties   -

        public sealed override int Size
        {
            get
            {
                return 8;
            }
        }
        public TagType TType
        {
            get;
            private set;
        }

        #endregion
        #region -  constructor  -

        public Dependency()
        {
            TType = new TagType();
        }
        
        #endregion
        #region -    methods    -

        public sealed override void Read(EndianReader br)
        {
            TType.Read(br);
            base.Read(br);
        }
        public sealed override void Write(EndianWriter bw)
        {
            TType.Write(bw);
            base.Write(bw);
        }
        public override string ToString()
        {
            return "Dependency";
        }

        #endregion
    }
}
