﻿using System.IO;
using System.Windows.Forms;
using LazyIO;

namespace HaloMap
{
    public class Ident : MetaItemBase
    {
        #region properties

        public override int Size
        {
            get
            {
                return 4;
            }
        }
        public int Value
        {
            get;
            protected set;
        }

        #endregion
        #region methods

        public void Update(int id)
        {
            Value = id;
        }
        public override void Read(EndianReader br)
        {
            Value = br.ReadInt32();
        }
        public override void Write(EndianWriter bw)
        {
            bw.Write(Value);
        }
        public override string ToString()
        {
            return "Ident";
        }

        #endregion
    }
}
