﻿using System;
using System.IO;
using System.Windows.Forms;
using LazyIO;

namespace HaloMap
{
    public sealed class TagType : MetaItemBase
    {
        #region properties

        public string Value
        {
            get;
            private set;
        }

        #endregion
        #region methods

        public sealed override void Read(EndianReader br)
        {
            Value = new string(br.ReadChars(4, EndianType.BigEndian));
        }
        public override void Write(EndianWriter bw)
        {
            char[] temp = Value.ToCharArray();
            Array.Reverse(temp);
            bw.Write(temp);
        }

        #endregion
    }
}
