﻿

using System.Text;
using LazyIO;
namespace HaloMap
{
    public class Unicode64 : String
    {
        #region constructor

        public Unicode64(int size)
            : base(size) { }

        #endregion
        #region methods

        public override void Read(EndianReader br)
        {
            Encoding decode = Encoding.Unicode;
            string temp = decode.GetString(br.ReadBytes(Size));
            Update(temp.Trim());
        }
        public override void Write(EndianWriter bw)
        {
            Encoding decode = Encoding.Unicode;
            byte[] bytes = decode.GetBytes(Value);
            int difference = bytes.Length - Size;
            if (difference == 0)
            {
                bw.Write(bytes);
            }
            else if (difference > 0)
            {
                bw.Write(bytes, 0, Size);
            }
            else
            {
                bw.Write(bytes);
                bytes = new byte[difference]; // all 0's
                bw.Write(bytes);
            }
        }

        #endregion
    }
}
