﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;
using LazyIO;
using System.Drawing;

namespace HaloMap
{
    public class ChunkPanel : HaloPanel
    {
        #region properties

        const int WM_PAINT = 0x00f;
        bool paint = true;

        ViewType viewing = ViewType.All;
        public ViewType Viewing
        {
            get;
            set;
        }
        bool showInvisibles = false;
        public bool ShowInvisibles
        {
            get;
            set;
        }

        Chunk chunkToView { get; set; }

        #endregion

        #region consructor

        public ChunkPanel( )
        {
            Dock = DockStyle.Fill;
            Viewing = ViewType.All;
            BackColor = Color.Transparent;
            Dock = DockStyle.Fill;
            DoubleBuffered = true;
        }

        #endregion

        #region methods

        public void SetObject(Chunk chunk)
        {
            if( chunkToView == null )
            {
                chunkToView = chunk;
                //LoadChunk( );
            }
            else
            {
                //ReloadChunk( );
            }
        }

        void OnShowInvisiblesChanged(bool value)
        {
            if( showInvisibles != value )
            {
                //LoadChunk( );
            }
        }

        void OnViewingChanged(ViewType value)
        {
            if( viewing == value )
            {
                // do nothing ( != doesn't work on enums )
            }
            else
            {
                //LoadChunk( );
            }
        }

        #endregion
    }
}
