﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using LazyIO;
using System.Drawing;

namespace HaloMap
{
    public class HaloPanel : Panel
    {
        #region properties

        const int WM_PAINT = 0x00f;
        bool paint = true;

        #endregion

        #region constructor

        public HaloPanel( )
            :base()
        {
            BackColor = Color.Transparent;
            Padding = new Padding(3);
            SetStyle(ControlStyles.AllPaintingInWmPaint, true);
            SetStyle(ControlStyles.UserPaint, true);
            SetStyle(ControlStyles.OptimizedDoubleBuffer, true);
            DoubleBuffered = true;
        }

        #endregion

        #region methods

        public void BeginUpdate( )
        {
            paint = false;
        }
        public void EndUpdate( )
        {
            paint = true;
        }
        protected override void WndProc(ref Message m)
        {
            if( m.Msg == WM_PAINT )
            {
                if( paint )
                {
                    base.WndProc(ref m);
                }
                else
                {
                    m.Result = IntPtr.Zero;
                }
            }
            else
            {
                base.WndProc(ref m);
            }
        }

        #endregion
    }
}
