﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Drawing;
using LazyIO;

namespace HaloMap
{
    public class MetaPanel : HaloPanel
    {
        #region properties

        public string TagType
        {
            get;
            set;
        }
        public ViewType Viewing
        {
            get;
            set;
        }

        TagList Tags { get; set; }
        StringList Strings { get; set; }

        Meta metaToView { get; set; }

        #endregion

        #region constructor

        public MetaPanel()
            :base()
        {
            TagType = "";
            Viewing = ViewType.All;
            AutoScroll = true;
            VerticalScroll.SmallChange = 15;
            VerticalScroll.LargeChange = 30;
        }

        #endregion

        #region methods

        public void LoadMeta(Meta meta,TagList tags, StringList strings)
        {
            if( meta == null )
                return;

            metaToView = meta;
            
            // if its the same tag type as last time then reload it
            // else set the tag type to the new one and populate the panel
            if( TagType.Equals(meta.Tag.Type) )
            {
                meta.RepopulatePanel(this);
            }
            else
            {
                TagType = meta.Tag.Type;
                meta.PopulatePanel(this, Viewing, tags, strings);
            }
        }

        #endregion
    }
}
