﻿

using System.Text;
using LazyIO;
namespace HaloMap
{
    public class HaloString
    {
        #region properties

        int Offset
        {
            get;
            set;
        }
        public short Index
        {
            get;
            set;
        }
        public string Value
        {
            get;
            set;
        }

        #endregion
        #region constructor

        public HaloString(int index)
        {
            Index = (short)index;
        }

        #endregion
        #region methods

        public void Read(EndianReader br)
        {
            Offset = (int)br.BaseStream.Position;
            StringBuilder sb = new StringBuilder();
            char c = br.ReadChar();
            while(c != '\0')
            {
                sb.Append(c);
                c = br.ReadChar();
            }
            Value = sb.ToString();
        }

        public void Write(EndianWriter bw)
        {
            bw.Seek(Offset);
            bw.Write(Value.ToCharArray());
        }

        public override string ToString()
        {
            return Value;
        }

        #endregion
    }
}
