﻿
using System.Collections.Generic;
using LazyIO;

namespace HaloMap
{
    public class StringList : List<HaloString>
    {
        #region properties

        MapHeader header
        {
            get;
            set;
        }

        #endregion
        #region constructor

        public StringList(MapHeader mapHeader)
        {
            header = mapHeader;
        }

        #endregion
        #region methods

        public void Read(EndianReader br)
        {
            br.Seek(header.StringsOffset);
            HaloString[] strings = new HaloString[header.StringsCount];
            for (int i = 0; i < strings.Length; i++)
            {
                strings[i] = new HaloString(i);
                strings[i].Read(br);
            }
            AddRange(strings);
        }
        public void Write(EndianWriter bw)
        {
            bw.Seek(header.StringsOffset);
            for (int i = 0; i < Count; i++)
            {
                HaloString hs = this[i];
                hs.Write(bw);
            }
        }

        #endregion
    }
}
